"use strict";

require("core-js/modules/es.array.find");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSelectedPadding = exports.isEnabled = void 0;

var _constants = require("./constants");

/* eslint-disable import/prefer-default-export */
var isEnabled = function isEnabled(options) {
  return options.length > 0;
};

exports.isEnabled = isEnabled;

var getSelectedPadding = function getSelectedPadding(options, currentValue) {
  var _options$find$value, _options$find;

  if (!isEnabled(options)) {
    return _constants.DEFAULT_PADDING;
  }

  if (currentValue === _constants.DEFAULT_PADDING) {
    return currentValue;
  }

  if (options.find(function (_ref) {
    var value = _ref.value;
    return value === currentValue;
  })) {
    return currentValue;
  }

  return (_options$find$value = (_options$find = options.find(function (option) {
    return option["default"];
  })) === null || _options$find === void 0 ? void 0 : _options$find.value) !== null && _options$find$value !== void 0 ? _options$find$value : _constants.DEFAULT_PADDING;
};

exports.getSelectedPadding = getSelectedPadding;